/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.protokollierung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.protokollierung.boundary.AbstractLoeschProtokollSearchParameters;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollChangeEvent;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollConversationStore;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollExtendedDAO;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollSearch;
import de.ivu.elect.business.protokollierung.boundary.LoeschProtokollSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.protokollierung.entity.LoeschProtokoll;
import de.ivu.elect.business.protokollierung.entity.LoeschProtokollMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractLoeschProtokollSearchView.COMPONENT_NAME)
@View(viewId = AbstractLoeschProtokollSearchView.VIEW_ID, useCase = UseCasePermission.LOESCH_PROTOKOLL_SEARCH)
public abstract class AbstractLoeschProtokollSearchView extends AbstractElectSearchView<LoeschProtokoll> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "loeschProtokollSearchView";
  
  public static final String VIEW_ID = "/protokollierung/loesch-protokoll-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractLoeschProtokollSearchView requestHandler;

  @Inject
  private transient LoeschProtokollExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(LoeschProtokollConversationStore.class)
  protected transient LoeschProtokollConversationStore conversationStore;

  @Inject
  protected transient LoeschProtokollSearch search;

  @Inject
  @ConversationGroup(AbstractLoeschProtokollSearchParameters.class)
  protected transient LoeschProtokollSearchParameters searchParameters;

  @Inject
  protected transient LoeschProtokollMeta entityMeta;

  public AbstractLoeschProtokollSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public LoeschProtokoll getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(LoeschProtokoll entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public LoeschProtokollSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<LoeschProtokoll> getEagerLoadingCollector() {
    return EagerLoadingCollector.<LoeschProtokoll> create();
  }

  @Override
  public List<LoeschProtokoll> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<LoeschProtokoll> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onLoeschProtokollChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) LoeschProtokollChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractLoeschProtokollSearchView {

    @View
    @Inject
    private transient Instance<AbstractLoeschProtokollSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractLoeschProtokollSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
